<?php
namespace Teknisa\MAN\Factories;

use Doctrine\ORM\EntityManager;

class Filial {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function buscaFiliaisCliente($params){
        $sql = "SELECT C.CDFILIAL, F.NMFILIAL, C.NRORG
                  FROM CLIENFILIAL C, FILIAL F
                 WHERE C.CDCLIENTE = :CDCLIENTE
                   AND C.CDFILIAL  = F.CDFILIAL
                   AND C.NRORG     = :NRORG
                   AND C.CDFILIAL NOT IN (SELECT CDFILIAL FROM CONSUMIFILIAL
                                            WHERE CDCONSUMIDOR = :CDCONSUMIDOR)
                 ORDER BY C.CDFILIAL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function buscaFiliaisConsumidor($params){
        $sql = "SELECT CO.CDCLIENTE, CO.CDCONSUMIDOR, CO.CDFILIAL, FI.NMFILIAL, CO.NRORG
                  FROM CONSUMIFILIAL CO, FILIAL FI
                 WHERE CO.CDFILIAL     = FI.CDFILIAL
                   AND CO.CDCLIENTE    = :CDCLIENTE
                   AND CO.CDCONSUMIDOR = :CDCONSUMIDOR
                   AND CO.NRORG        = :NRORG
                 ORDER BY CO.CDFILIAL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function saveFiliaisConsumidor($params){
        $sql = "INSERT INTO CONSUMIFILIAL
                  (CDCLIENTE, CDCONSUMIDOR, CDFILIAL) 
                VALUES
                  (:CDCLIENTE, :CDCONSUMIDOR, :CDFILIAL)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function removeFiliaisConsumidor($params){
        $sql = "DELETE FROM CONSUMIFILIAL
                WHERE CDCLIENTE    = :CDCLIENTE
                AND   CDCONSUMIDOR = :CDCONSUMIDOR
                AND   CDFILIAL     = :CDFILIAL";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
}