<?php 

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;
use \Doctrine\ORM\EntityManager;


class RelComandasEmAbertoService {
    
	protected $entityManager; 

	public function __construct(EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	private function setParameters($conditions) {
	    return array (
    	      ':NRORG' => $conditions['NRORG'],
              ':CDFILIAL' => $conditions['CDFILIAL'],
              ':CDLOJA' =>  array_key_exists('CDLOJA', $conditions) ? implode('_',$conditions['CDLOJA']) : 'T'
        );
    }
    
    public function getComandasEmAberto($conditions) {
      try{
        $params = $this->setParameters($conditions);
        return $this->entityManager->getConnection()->fetchAll(self::REL_COMANDAS_EM_ABERTO, $params);
      }catch (Exception $e){
        throw $e;
      }
    }

  const REL_COMANDAS_EM_ABERTO = "SELECT FI.NMFILIAL, LJ.NMLOJA, IT.CDLOJA, IT.CDFILIAL, 
       DECODE(SUBSTR(IT.DSCOMANDAPEND,1,4),'PKC_',SUBSTR(IT.DSCOMANDAPEND,5,10), 
       DECODE(SUBSTR(IT.DSCOMANDAPEND,1,4),'CMD_',SUBSTR(IT.DSCOMANDAPEND,5,10),IT.DSCOMANDAPEND)) AS DSCOMANDAPEND,
       IT.DTHRINCOMVENPEN,
       (IT.CDFILIAL||' '||FI.NMFILIAL||' Loja: '||IT.CDFILIAL||IT.CDLOJA) LABELFILILOJA,
       (DSCOMANDAPEND|| ' - Data abert.: '||DTHRINCOMVENPEN|| ' - Nome consumidor: '||NVL(CN.NMCONSUMIDOR, 'Não consta')||
        ' - RG.: '||NVL(CN.NRRGCONSUMID, 'Não consta')|| ' - CPF: '||NVL(CN.NRCPFRESPCON, 'Não consta')||
        ' - Nº Tel.: '||NVL(CN.NRTELECONS, 'Não consta')|| ' - Celular: '||NVL(CN.NRTELE2CONS, 'Não consta')) LABELCOMANDA,
       CN.NMCONSUMIDOR, CN.NRRGCONSUMID, CN.NRCPFRESPCON, CN.NRTELECONS, CN.NRTELE2CONS, 
       IT.NRCOMANDAPEND,
       SUM((IT.QTPRODCOMVENPEN * IT.VRPRECCOMVENPEN) + IT.VRACRCOMVENPEND - IT.VRDESCCOMVENPEN) AS VUNIT,
       IT.CDCONSUMIDOR, (PR.CDPRODUTO || ' ' || PR.NMPRODUTO) AS PRODUTO, SUM(IT.QTPRODCOMVENPEN) AS QTDE,
       SUM(IT.VRACRCOMVENPEND) AS ACRESCIMO, SUM(IT.VRDESCCOMVENPEN) AS DESCONTO,
       SUM((IT.QTPRODCOMVENPEN*IT.VRPRECCOMVENPEN)-IT.VRDESCCOMVENPEN+IT.VRACRCOMVENPEND) AS VRTOTAL
  FROM ITCOMANDAPEND IT, PRODUTO PR, CONSUMIDOR CN, LOJA LJ, FILIAL FI
 WHERE (IT.CDCONSUMIDOR = CN.CDCONSUMIDOR(+))
   AND (IT.CDCLIENTE    = CN.CDCLIENTE   (+))
   AND (IT.CDLOJA       = LJ.CDLOJA      )
   AND (IT.CDFILIAL     = LJ.CDFILIAL    )
   AND (IT.CDFILIAL     = FI.CDFILIAL    )
   AND (IT.CDFILIAL     = :CDFILIAL    )
   AND (IDSTPRCOMVENPEN NOT LIKE '6')
   AND (UPPER(IT.DSCOMANDAPEND) NOT LIKE 'RES%')
   AND (UPPER(IT.DSCOMANDAPEND) NOT LIKE 'DLV%')
   AND (UPPER(IT.DSCOMANDAPEND) NOT LIKE 'PKR%')
   AND ((INSTR(:CDLOJA, (IT.CDFILIAL||IT.CDLOJA)) <> 0) OR (:CDLOJA = 'T'))
   AND IT.CDPRODUTO = PR.CDPRODUTO
 GROUP BY  
       FI.NMFILIAL, LJ.NMLOJA, IT.CDLOJA, IT.CDFILIAL, IT.DSCOMANDAPEND, IT.DTHRINCOMVENPEN,
       CN.NMCONSUMIDOR, CN.NRRGCONSUMID, CN.NRCPFRESPCON, CN.NRTELECONS, CN.NRTELE2CONS, IT.NRCOMANDAPEND,
       IT.CDCONSUMIDOR, PR.CDPRODUTO, PR.NMPRODUTO
 ORDER BY
       IT.CDFILIAL, IT.CDLOJA, NRCOMANDAPEND, IT.DSCOMANDAPEND";
}